/*
 * ActionRegistry.hpp
 *
 *  Created on: Jan 7, 2010
 *      Author: crueger
 */

#ifndef ACTIONREGISTRY_HPP_
#define ACTIONREGISTRY_HPP_

#include <string>
#include <map>

#include "Patterns/Singleton.hpp"

class Action;

class ActionRegistry : public Singleton<ActionRegistry>
{
  friend class Singleton<ActionRegistry>;
public:
  Action* getActionByName(const std::string);
  void registerAction(Action*);

  std::map<const std::string,Action*>::iterator getBeginIter();
  std::map<const std::string,Action*>::iterator getEndIter();

private:
  std::map<const std::string,Action*> actionMap;

private:
  ActionRegistry();
  virtual ~ActionRegistry();
};

#endif /* ACTIONREGISTRY_HPP_ */
